﻿// tictactoe.cpp
#include <iostream>
#include <string>
#include "tictactoe.h"

tictactoe::tictactoe()
{
	//srand(time(0));
	player = 1;
	totalturns = 0;
	// new player setup
	numofplayers = 2;
	playertype[1] = 1;
	playertype[2] = 0;
	// playerType[player] is human (1)
	// playerType[player] is computer (0)
	//playerType[3] = 0;  // playerType[player] is computer (0)
	for (int i = 0; i < 9; i++)
		pos[i] = 0;
}

tictactoe::~tictactoe()
{
}

void tictactoe::drawBoard()
{
	std::cout << std::endl
		<< pos[0] << " │ " << pos[1] << " │ " << pos[2]
		<< "\n──┼───┼──\n"
		<< pos[3] << " │ " << pos[4] << " │ " << pos[5]
		<< "\n──┼───┼──\n"
		<< pos[6] << " │ " << pos[7] << " │ " << pos[8]
		<< std::endl;
}

void tictactoe::printTurn()
{
	std::cout << "\nPlayer " << player << "'s turn.\n";
}

void tictactoe::nextTurn()
{
	totalturns++;

	if (++player > numofplayers)
		player = 1;
}

bool tictactoe::playerHuman()
{
	return playertype[player];
}

int tictactoe::humanMove()
{
	int move;
	bool flag = false;
	do
	{
		std::cout << "\nEnter your move: ";
		std::cin >> move;
		if (flag) {
			std::cout << "Wrong move, try again!";
		}
		flag = true;
		move--;     // so user can enter 1-9 instead of 0-8
	} while (move < 0 || move > 8 || pos[move] != 0);
	pos[move] = player;
	return move;
}

void tictactoe::computerMove()
{
 int move;
 do
 {
 move = rand() % 9;     
 } while (move < 0 || move > 8 || pos[move] != 0);
 pos[move] = 2;
}

bool tictactoe::winner()
{
	int board[8][3] = { { 0,1,2 },
	{ 3,4,5 },
	{ 6,7,8 },
	{ 0,3,6 },
	{ 1,4,7 },
	{ 2,5,8 },
	{ 0,4,8 },
	{ 2,4,6 } }; // winning possibilities

	for (int i = 0; i < 8; i++) // scroll through possibilities
	{
		if ((pos[board[i][0]] == pos[board[i][1]])
			&& (pos[board[i][1]] == pos[board[i][2]])
			&& pos[board[i][0]] != 0)
		{
			int whichplayer = pos[board[i][0]];
			if (whichplayer == 1) {
				std::cout << "\nPlayer " << pos[board[i][0]] << " wins!\n\n";
			}
			return 1;    // return winner true
		}
	}

	bool isdraw = true;
	for (int i = 0; i < 9; i++) {
		if (pos[i] == 0) {
			isdraw = false;
		}
	}
	if (isdraw) {
		std::cout << "Game is a draw";
	}
	return 0;   // winner false
}

bool tictactoe::fullBoard()
{
	if (totalturns == 9)
	{
		std::cout << "\nTie game!\n\n";
		return 1;
	}
	else
		return 0;
}
